Package tigase.vhosts

## Class VHostItemExtension<T extends VHostItemExtension<T>>

- java.lang.Object
- - tigase.vhosts.VHostItemExtension<T>

- All Implemented Interfaces:
    `VHostItemExtensionIfc<T>`
  Direct Known Subclasses:
    `AbstractVHostItemExtension`

      public abstract class VHostItemExtension<T extends VHostItemExtension<T>>
      extends java.lang.Object
      implements VHostItemExtensionIfc<T>

  Abstract class required to be a superclass for all classes implementing `VHostItemExtensionIfc`.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `VHostItemExtension()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract T` | `mergeWithDefaults​(T defaults)` | Abstract method required to be implemented for merging values stored in this instance with default settings stored in the default virtual host item (global or default settings of the installation).
    `java.lang.String` | `toString()` | Generic implementation of a method which combines data returned by `toDebugString()` with class name for easier debugging.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.vhosts.VHostItemExtensionIfc

      `addCommandFields, getId, initFromCommand, initFromElement, toDebugString, toElement`

- - ### Constructor Detail

    - #### VHostItemExtension

          public VHostItemExtension()

  - ### Method Detail

    - #### mergeWithDefaults

          public abstract T mergeWithDefaults​(T defaults)

      Abstract method required to be implemented for merging values stored in this instance with default settings stored in the default virtual host item (global or default settings of the installation).
      Parameters:
        `defaults` - - instance of the extension with default values
      Returns:
        instance of the extension containing merged values

    - #### toString

          public java.lang.String toString()

      Generic implementation of a method which combines data returned by `toDebugString()` with class name for easier debugging.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        - class